---
title: Matching web features to browser release version numbers
slug: MDN/Contribute/Processes/Matching_features_to_browser_version
tags:
  - Blame
  - Chrome
  - Documentation
  - Edge
  - Firefox
  - Guide
  - MDN
  - MDN Meta
  - Meta
  - Meta Docs
  - Microsoft
  - Mozilla
  - Opera
  - Releases
  - Safari
  - Versions
  - Writing Documentation
  - google
---
<p>{{Draft}}{{MDNSidebar}}</p>

<p>When contributing to the documentation on the MDN web docs site, you will often need to locate and identify version-specific details for a given browser, such as which versions of each major browser implement support for the feature you're documenting. <span class="seoSummary">This article provides tips and pointers to help you figure out which version of each major browser introduced a given feature, and when it was enabled by default.</span></p>

<div class="notecard note">
<p>In this article, the term <strong>feature</strong> is used to refer to anything that might need to be documented on MDN. This includes APIs, HTML elements, new HTML attributes, new CSS properties, new possible values for CSS properties, and so forth. Anything that needs to be documented, from very small to very large.</p>
</div>

<h2 id="Chrome">Chrome</h2>

<p>There are various ways to locate information about the release of a feature on Chrome. Some of them are quite easy but less likely to provide the details you need, while others take some significant work but are much more likely to provide precise details.</p>

<h3 id="Useful_resources">Useful resources</h3>

<p>The following sites and tools are helpful when trying to track down history information for a feature in Chrome:</p>

<ul>
 <li><a href="https://www.chromium.org/">The Chromium project</a></li>
 <li><a href="https://bugs.chromium.org/">Chromium bug database</a></li>
 <li><a href="https://chromium.googlesource.com/chromium">Chromium source code</a></li>
 <li><a href="https://chromium.googlesource.com/chromium/src.git/+refs">Chromium source code by release version number</a></li>
 <li><a href="https://www.chromestatus.com/">Google Chrome Platform Status</a></li>
 <li><a href="https://cs.chromium.org/">Chromium Code Search</a></li>
 <li><a href="https://storage.googleapis.com/chromium-find-releases-static/index.html">Find Releases Tool</a></li>
 <li><a href="https://cs.chromium.org/chromium/src/android_webview/tools/system_webview_shell/test/data/webexposed/global-interface-listing-expected.txt?g=0">List of everything exposed to the Web in Chrome</a></li>
 <li><a href="https://cs.chromium.org/chromium/src/android_webview/tools/system_webview_shell/test/data/webexposed/not-webview-exposed.txt">Interfaces not exposed to WebView</a></li>
 <li><a href="https://bugs.webkit.org/">WebKit bugs</a></li>
</ul>

<h3 id="Getting_the_Chrome_version_for_a_changeset_or_revision">Getting the Chrome version for a changeset or revision</h3>

<p>Given a particular Chrome changeset or revision number, you can look up the version number of Chrome that first shipped with those changes included using Google's <a href="https://storage.googleapis.com/chromium-find-releases-static/index.html">Find Releases tool</a>. As long as the change happened after the Chrome code moved to <code>git</code>, this will return the corresponding version number.</p>

<p>For example, given the string <code>05b49ea1</code>, the tool first looks for a match among the full commit changeset numbers, finds none, then looks at the prefixed short commits:</p>

<p><img alt="Screenshot of the Chromium project's Find Releases tool" src="https://mdn.mozillademos.org/files/16573/find-releases-tool.png" style="border-style: solid; border-width: 1px; height: 144px; width: 412px;"></p>

<p>Here, we see that changeset <code>05b49ea1</code> was first landed for Chrome 56, but was then backported to Chrome 55 and was presumably shipped there. This assumes the feature was not backed out at some point, and it's important to check on this.</p>

<h3 id="Version_numbers_for_Chrome_for_Android">Version numbers for Chrome for Android</h3>

<p>Chrome for Android shares version numbers with the desktop release, although not every desktop Chroime version has a corresponding Android version. The table below will help map features to versions of Chrome for Android</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">If the change occurred in Chrome (Desktop) version:</th>
   <th scope="col">Then the change was introduced into Chrome for Android version:</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>1 – 18</td>
   <td>18 (18 is the first version of Chrome for Android)</td>
  </tr>
  <tr>
   <td>19-25</td>
   <td>25 (there were no Chrome for Android versions 19 through 24)</td>
  </tr>
  <tr>
   <td>26 and higher</td>
   <td>The same version as desktop</td>
  </tr>
 </tbody>
</table>

<h3 id="Version_numbers_for_features_in_Android_WebView">Version numbers for features in Android WebView</h3>

<p>The Android WebView component switched to being based off the latest version of Chrome during the Chrome 37 lifecycle, so any feature that's present in Android WebView <em>and</em> was introduced during or after the Chrome 37 time period should have the same versions as the Chrome release at the same time. For example, if a feature is added to WebView while Chrome 55 is current, then the value of <code>version_added</code> is <code>55</code>.</p>

<p>If a feature is added to WebView prior to the Chrome 37 time period, and its version number is not known (looking these up is a more difficult process), specify <font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.498039);">≤37</span></font> as the version. Otherwise, if you do know the WebView component's version number, use that instead.</p>

<h4 id="Features_excluded_from_WebView">Features excluded from WebView</h4>

<p>One useful resource is <a href="https://cs.chromium.org/chromium/src/android_webview/tools/system_webview_shell/test/data/webexposed/not-webview-exposed.txt">this file which lists the interfaces and/or interface members</a> which are not available in a WebView.</p>

<pre class="notranslate">interface HTMLIFrameElement : HTMLElement
    getter allowPaymentRequest
    setter allowPaymentRequest</pre>

<p>This indicates that for the {{domxref("HTMLIFrameElement")}} interface (representing the members of an {{HTMLElement("iframe")}} element), the {{domxref("HTMLIFrameElement.allowPaymentRequest", "allowPaymentRequest")}} property's value can be neither read not set, essentially meaning the property is not available. This property is part of the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a>, which is not yet supported in WebViews.</p>

<p>If only an interface line is included in the exclusion list, then the entire interface is unavailable in WebViews.</p>

<p>Items listed under "<code>[GLOBAL OBJECT]</code>" are globals which are not available on WebView.</p>

<h3 id="View_a_specific_releases_code">View a specific release's code</h3>

<p>The Chromium source code repository maintains a set of tags, one for each release of Chrome going back to version 10.0.601.0. A <a href="https://chromium.googlesource.com/chromium/src.git/+refs">list of links to these tags</a> is available. This is helpful when you need to check for the presence of a given feature in a particular release, or to see if a given change was backed out or not prior to the release of a given version of Chrome.</p>

<h2 id="Edge">Edge</h2>

<p><em>If you have insights into locating release versions for changes to Edge, please consider helping us write this section...</em></p>

<h3 id="Useful_resources_2">Useful resources</h3>

<ul>
 <li><a href="https://developer.microsoft.com/en-us/microsoft-edge/platform/status/">Microsoft Edge web platform features status and roadmap</a></li>
 <li><a href="https://developer.microsoft.com/en-us/microsoft-edge/platform/issues/">Microsoft Edge issue tracker</a></li>
</ul>

<h3 id="EdgeHTML">EdgeHTML</h3>

<p>Before Edge switched to Chromium, it used an engine developed by Microsoft called EdgeHTML. These resources will help you identify when features were added or removed in EdgeHTML-based versions of Edge—that is, Edge version 18 and earlier.</p>

<h3 id="Blink_Chromium">Blink (Chromium)</h3>

<p>After Edge 18, Edge adopted the Blink engine, becoming based upon Chromium. The version number jumped to 79, to match the Chromium version number. While most features will be the same between all Chromium browsers at the same version number, there may be some exceptions. Here are some resources to help you identify those:</p>

<h2 id="Firefox">Firefox</h2>

<p>There are several ways you can determine which browser release a feature arrived in. We'll look at a few of them, starting with the quickest and easiest way. Before we look at those, though, let's review some basic information you need before applying any of these techniques.</p>

<h3 id="Using_Mercurial_blame">Using Mercurial blame</h3>

<p>You can use Mercurial <strong>blame</strong> to identify the changeset that introduced the feature you're interested in. If you're unfamiliar with the blame feature provided by modern version control systems (including both Mercurial and git), it's a tool that displays the revision number of the most recent modification to every line in the file (or span of lines, if more than one in a row last changed in the same revision).</p>

<p>The specific appearance of the display will vary depending on what tool you're using to view the blame information; for example, Mozilla DXR's <a href="https://hg.mozilla.org/mozilla-central/annotate/c2593a3058afdfeaac5c990e18794ee8257afe99/dom/webidl/RTCPeerConnection.webidl#l">output for the <code>RTCPeerConnection.webidl</code> file</a> looked like this when this article was written:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16504/hg-tooltip-revision.png" style="border-style: solid; border-width: 1px; width: 676px;"></p>

<p>Here, the mouse is pointing at a row with the revision number <code>199991</code> beside it. This has opened up a tooltip with details about that revision: It was created for bug 1032835, entitled "addTrack/removeTrack on-top of existing implementation". The tooltip includes several links which can be helpful:</p>

<dl>
 <dt>&lt;40 digit hexadecimal changeset number&gt;</dt>
 <dd>The changeset number is the first thing shown in the tooltip. This link will take you to a page describing this file as it pertains to the changeset, with the changes highlighted. On the single-file view within a changeset, clicking the <code>changeset</code> link at the top of the page will take you to the changeset's overview. From there, the information under {{anch("From a Mercurial changeset number")}} will show you how to track down the version information.</dd>
 <dt>Bugzilla bug link</dt>
 <dd>A link back to the bug on Bugzilla that corresponds to this change. You may find useful information in the bug, including potentially the version number the change shipped in, but odds are good that's where you started.</dd>
 <dt>Parent changeset revision number</dt>
 <dd>An integer value corresponding to the revision number of the changeset that these changes are based on. This version is what makes up the "before" in a diff of this changeset.</dd>
 <dt><code>diff</code></dt>
 <dd>A link that will produce a diff showing the differences between the parent changeset and the changeset that introduced the change you're looking at.</dd>
 <dt><code>changeset</code></dt>
 <dd>A link to the overview page for the entire changeset that includles the changes made to this line of code. This page should give you the information you require; see {{anch("From a Mercurial changeset number")}} for details.</dd>
</dl>

<div class="notecard note">
<p><strong>Note</strong><strong>:</strong> If you aren't able to find the change because it apparently happens before Firefox was migrated to Mercurial from CVS, try using Mercurial blame on the <a href="https://hg.mozilla.org/mozilla-unified/">Unified Firefox repository</a>, which has tags in place, each representing the code state at specific points in the history of the project, including each beta and each release build. See {{SectionOnPage("/en-US/docs/MDN/Contribute/Processes/Browser_information_resources", "Unified Firefox repository")}} for details.</p>
</div>

<h3 id="Getting_the_Firefox_release_for_a_bug_number">Getting the Firefox release for a bug number</h3>

<p>If you have the bug number corresponding to the bug that implemented the feature, and the bug isn't incredibly old, you can usually get the version number corresponding to the implementation of the feature straight from the bug. This information can be found in one of a few different ways.</p>

<p>Consider {{bug(1435161)}}. This bug covers implementing the {{domxref("PaymentReponse.retry()")}} method. If you look at that bug, you'll see the information you need right there at the top:</p>

<p><img alt='Screenshot showing "RESOLVED FIXED in Firefox 64" at the top of the Bugzilla screen' src="https://mdn.mozillademos.org/files/16494/bugzilla-fixedin-top.png" style="border-style: solid; border-width: 1px; width: 487px;"></p>

<p>Right below the bug summary, you see the text "RESOLVED FIXED in Firefox 64". This corresponds to the presence of the tracking flag named <code>firefox45</code> having the value <code>fixed</code>.  On older bugs, before the release-numbered tracking flags were added, you might instead find one of these:</p>

<ul>
 <li>
  <p>A tracking flag named <code>relnote-firefox</code> with the status set to the version of Firefox the feature arrived in. This tracking flag is intended to indicate when a feature needs to be mentioned in the release notes for the browser, but serves just as well to tell us when a feature was added.</p>

  <p><img alt="Screenshot showing the relnote-firefox tracking flag used to indicate a version number" src="https://mdn.mozillademos.org/files/16495/bugzilla-relnote-firefox.png" style="border-style: solid; border-width: 1px; width: 347px;"></p>
 </li>
 <li>
  <p>The Target field in the Tracking group in Bugzilla is set to <code>mozillaN</code>, where <code>N</code> is the version number of Firefox. The trick to watch for is that this is sometimes inaccurate, as it represents when it was hoped to ship, not necessarily when it was actually released. Be sure to review the comments on the bug to ensure that it didn't miss its planned release.</p>

  <p><img alt='Screenshot showing the Bugzilla Target field indicating a release target of "mozilla15" or Firefox 15' src="https://mdn.mozillademos.org/files/16496/bugzilla-target.png" style="border-style: solid; border-width: 1px; width: 449px;"></p>
 </li>
</ul>

<h3 id="From_a_the_name_of_a_Web_API_interface_or_member">From a the name of a Web API interface or member</h3>

<p>If you're updating compatibility data for a given API interface, or for a property, method, or other feature within that interface, you may not necessarily have a bug number or changeset number to start from. This means doing a little detective work is in order. There are two approaches to take: you can try searching Bugzilla, looking for a bug that covers the change you want to identify, or you can isolate the information directly from the source tree.</p>

<h4 id="Finding_a_matching_bug_in_Bugzilla">Finding a matching bug in Bugzilla</h4>

<p>A good place to start: do a Bugzilla search for a bug that mentions what you're looking for:</p>

<ul>
 <li>If you're looking for the addition of an entire interface, try searching for the name of that interface or, failing that, the name of the API that includes the interface within the summary of the bug and whose status is <code>RESOLVED</code>. For example, if looking for information about when {{domxref("CustomEvent")}} might have arrived, <a href="https://bugzilla.mozilla.org/buglist.cgi?list_id=14565782&amp;short_desc_type=allwordssubstr&amp;short_desc=CustomEvent&amp;classification=Client%20Software&amp;classification=Components&amp;query_format=advanced&amp;bug_status=RESOLVED&amp;bug_status=VERIFIED&amp;bug_status=CLOSED">this would be the search</a>. This returns a few results, the second of which is the one we're looking for: {{bug(427537)}}, "Implement CustomEvent DOM3 specification". Armed with that bug number, we can go back to the {{anch("Getting the Firefox release for a bug number", "previous section")}} and determine when this interface was added to Firefox.</li>
 <li>If you're looking for a property or method on an interface having been added, try searching for the interface name and the method or property name both, similar to the previous suggestion. You may find that the method was added along with the entire interface or API, so be sure to watch for the addition of the broader area too.</li>
 <li>If all else fails, just search for the API name, ideally limiting the search to bugs that are also resolved, as in the first suggestion above.</li>
</ul>

<p>If you find a bug that corresponds to the feature you need compatibility information for, you can then go to {{anch("Getting the Firefox release for a bug number")}} to review how to isolate that compatibility data from the bug's contents.</p>

<h4 id="Finding_the_version_from_the_source_tree">Finding the version from the source tree</h4>

<p>If you don't find the information you need in <a href="https://bugzilla.mozilla.org/">Bugzilla</a>, you can get it by tracking it down in the Firefox source tree. For the purposes of this explanation, we'll be using the <a href="https://dxr.mozilla.org/mozilla-central/source/">Mozilla DXR</a> tool and the <a href="https://hg.mozilla.org/mozilla-central/">Mozilla source tree</a> browsable on the web to locate the information.</p>

<h5 id="For_web_API_features">For web API features</h5>

<p>A web API feature change corresponds to adding, removing, or altering the signature or contents of any of the following:</p>

<ul>
 <li>An interface</li>
 <li>A method or property of an interface</li>
 <li>A constant defined by an API's specification</li>
 <li>A data type (enum, typedef, or similar)</li>
</ul>

<p>The easiest way to identify the compatiblity of a feature is to look for when the feature was added to or altered to match the compatibility point you're looking for within the <a href="/en-US/docs/Glossary/WebIDL">WebIDL</a> file that describes the corresponding interface. There are a few ways you can locate this file, depending on how the API is implemented and how old it is. From most to least likely to work, here they are:</p>

<ol>
 <li>
  <p>For a given interface named <code>InterfaceName</code>, go to <a href="https://dxr.mozilla.org/mozilla-central/source/">DXR</a> and type <kbd>file:<em>InterfaceName</em>.webidl</kbd> in the search box at the top of the page and pressing <kbd>Enter</kbd>. You will probably have to then click on the name of the file in a list of files (usually only a one-file-long list).</p>
 </li>
 <li>
  <p>If the interface isn't found, then search for it by looking for the main interface in the API. For example, a large number of the interfaces, types, and so on for <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> are located in the file <code>RTCPeerConnection.webidl</code> in the Firefox source code, so if you don't find a WebRTC interface by its name, look in that file instead.</p>
 </li>
 <li>
  <p>Failing that, try looking for <kbd>file:<em>interfacename</em>.idl</kbd> to see if perhaps the interface is one which is still using the older Mozilla <a href="/en-US/docs/Archive/Mozilla/XPIDL">XPIDL</a> syntax to describe it. This should not happen very often, if at all.</p>
 </li>
</ol>

<p>Once in the WebIDL file, click the "Blame" link under "VCS Links" in the Navigation box near the top-right corner of the DXR page.</p>

<p><img alt="Screenshot of the DXR Navigation box" src="https://mdn.mozillademos.org/files/16526/dxr-navigation-box.png" style="border-style: solid; border-width: 1px; width: 197px;"></p>

<p>Once in the blame view, hover the mouse cursor over the revision number at the left side of the WebIDL on the same line as (or the first revision number found immediately above) the line of WebIDL corresponding to the feature you're interested in. For example, if you're looking for when the <code>RTCPeerConnection</code> method <code>addTrack()</code> was added to Firefox:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16504/hg-tooltip-revision.png" style="border-style: solid; border-width: 1px; width: 676px;"></p>

<p>This shows you information about the changeset; if the information shown is what you're looking for, click the <code>changeset</code> link in the tooltip popup, then see {{anch("From a Mercurial changeset number")}} for details on how to get the version information you need from there.</p>

<p>If you can't find the changeset you need just by browsing the blame page, the next thing to try is to look through the revision history. Click on the <code>revisions</code> link at the top of the Mercurial blame page, or the "Log" link in the Navigation box on the DXR page. This will present a list of every changeset that altered the file you're looking at. Look for a revision that matches the feature change you're interested in; if you find a promising revision, click the <code>diff</code> link next to that revision.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16502/hg-revisions-ontrack.png" style="border-style: solid; border-width: 1px; width: 878px;"></p>

<p>This takes you to the changeset details page. From here, you can collect the information you need as covered in {{anch("From a Mercurial changeset number")}}.</p>

<h5 id="For_HTML_elements">For HTML elements</h5>

<p>A good place to start is the interface that is used to implement the element. For example, to get information about changes made to the {{HTMLElement("marquee")}} element, type <kbd>file:HTMLMarqueeElement.webidl</kbd> into the DXR search box and press <kbd>Enter</kbd>. Click on the returned file name to open the WebIDL and see if you can isolate the information you require from that.</p>

<p>If the change is one that can't be determined from changes to WebIDL, you'll have to figure out where in the code the change is represented. You don't have to find all the code that implements the change. Instead, look for a line that's representative of the change. That is, a line of code that would only be present in its current form if that change has taken place. Some examples:</p>

<ul>
 <li>A new or changed entry in an array of property names</li>
 <li>A new or changed constant definition used only by the feature you're documenting</li>
 <li>The first line of the C++ function implementing the feature (or a function that's used only by the implementation of the feature). The existence of this line indicates the feature exists, but you can also look for changes to the parameter list.</li>
 <li>A <code>return</code> operation which changes from returning nothing or <code>undefined</code> to some new value, or changes return type.</li>
</ul>

<p>Locating an appropriate line of code can be tricky, and can take some practice. It's not difficult, but it does mean learning some techniques. a few suggestions:</p>

<ul>
 <li>To locate source files related to an element, use the search <kbd>file:<em>Elementname</em></kbd> in DXR. This will return a list of the files related to implementing that element.</li>
 <li>To find the code that implements a given method on an element, run the search command <kbd>file:Elementname function:functionname</kbd>. For example, to locate the implementation of the <code>play()</code> method for media elements: <kbd>file:HTMLMediaElement function:play</kbd>.</li>
 <li>To locate the code implementing a property or other ID on an element, run the command file: <kbd>file:Elementname id:propertyname</kbd>. For instance, to locate the code implementing the <code>HTMLMediaElement</code> property <code>duration</code>, run the search <kbd>file:HTMLMediaElement id:duration</kbd>.</li>
</ul>

<div class="notecard note">
<p><strong>Note:</strong> If none of those tips for searching DXR help, click on the "Operators" button at the far right end of the search box. This will open a panel listing all the keywords you can use to perform special searches, such as <code>type:</code> to look for data types or classes in C, Python, or Rust source files.</p>
</div>

<p>Once you've found a representative line of code, the goal is to identify the Firefox changeset—and from that the Firefox version—that first introduced that line of code, or first altered that line of code to match the feature change you're documenting.</p>

<h5 id="For_CSS_features">For CSS features</h5>

<p>CSS changes can be a little bit tricker to nail down. The Firefox repositories don't track history of any files that record the availability of given properties, for example.</p>

<p>To determine when support for a given <strong>value</strong> for a property was added, try opening the file <code><a href="https://dxr.mozilla.org/mozilla-central/source/layout/style/nsCSSProps.cpp">nsCSSProps.cpp</a></code> and looking through the tables of property values found there. These tables are all of type <code>KTableEntry</code>; each entry in the tables maps a CSS keyword to a value used to represent it internally. For instance, to determine when Firefox added support for the CSS Scroll Snap type value <code>proximity</code>, look through <code>nsCSSProps.cpp</code> until you find in the table <code>nsCSSProps::kScrollSnapTypeKTable</code>:</p>

<pre class="brush: cpp notranslate">const KTableEntry nsCSSProps::kScrollSnapTypeKTable[] = {
  { eCSSKeyword_none,      NS_STYLE_SCROLL_SNAP_TYPE_NONE },
  { eCSSKeyword_mandatory, NS_STYLE_SCROLL_SNAP_TYPE_MANDATORY },
  { eCSSKeyword_proximity, NS_STYLE_SCROLL_SNAP_TYPE_PROXIMITY },
  { eCSSKeyword_UNKNOWN,   -1 }
};</pre>

<p>And there it is. From here, it's back to the same blame and/or revision list technique covered under {{anch("Using Mercurial blame")}}.</p>

<h3 id="From_a_Mercurial_changeset_number">From a Mercurial changeset number</h3>

<p>Mercurial changeset numbers are 40-digit hexadecimal numbers that can be abbreviated to any unique number of leading characters; usually you will see them presented using only the first 12 digits. You might find a changeset number in any number of places, including listed in bug comments, in Mercurial blame, log, and diff output, and so forth.</p>

<p>Each changeset describes all the changes made in a revision as well as a link to the bug it's associated with, the author of the changes, the date and time it was committed to Mercurial, and so forth. One of those places, as we've seen above, is the <code>changeset</code> link in the tooltip you get when hovering over a revision number in the Mercurial blame or diff output.</p>

<p>You can also reach a changeset's overview more directly. If you're looking at the <a href="https://hg.mozilla.org/mozilla-central/">Mozilla Mercurial</a> web interface, you can search for the changeset number, then click through to the changeset in the search results. Or you can go to the URL <code>https://hg.mozilla.org/mozilla-central/rev/&lt;changeset-number&gt;</code>, which takes you directly to the changeset overview.</p>

<p>For example, if I have the changeset number <code>79525105ef9a</code>, I want to visit <a href="https://hg.mozilla.org/mozilla-central/rev/79525105ef9a">https://hg.mozilla.org/mozilla-central/rev/79525105ef9a</a>. This brings up a page that looks like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16505/hg-changeset.png" style="border-style: solid; border-width: 1px; width: 1788px;"></p>

<p>Below this is a list of the files that changed followed by the actual diffs showing the specific changes made.</p>

<p>There is an absolute gold mine of useful information on this page, including:</p>

<dl>
 <dt>first release with</dt>
 <dd>
 <p>This section provides a list of the first build of Firefox that includes the change for each of the major platforms (macOS, Linux (32-bit and 64-bit), and Windows (32-bit and 64-bit). The changeset number of the last changes that went into the build, the version number of Firefox that build was part of, the Firefox build number, and a link to the complete set of source files for that release.</p>

 <p>Having the versions broken down by platform is useful because it can help you in situations where a feature is added to Windows before it reaches the Mac, or if it only applies to one platform at all.</p>
 </dd>
 <dt>last release without</dt>
 <dd>This provides the same information as "first release with," but for the build immediately prior to the one covered by "first release with."</dd>
 <dt>releases</dt>
 <dd>Provides the version numbers of Firefox that first introduced this change as well as a build number, similar to what's included in "last release without." The difference here is the "pushlog to previous" link, which provides a list of every single revision from the previous release to this one.</dd>
</dl>

<p>At any rate, <strong>the version number next to "first release with" is the number you want</strong>, unless the change was later backed out. That's always a situation you need to be ready to handle. Make sure there aren't any comments late in the bug saying something to that effect, and keep an eye out for other bugs related to the same feature that indicate a backing-out occurred. This doesn't happen often, but it does happen.</p>

<h3 id="Checking_for_platform-specific_availability">Checking for platform-specific availability</h3>

<p>Most of the time, APIs and other features are present in both the desktop and Android versions of Firefox, or in all desktop versions (Mac, WIndows, and Linux). There are exceptions, however. Here are some tips that will help you identify those exceptions.</p>

<ul>
 <li>
  <p>Find the bug that introduces the change you're looking for, then look at the tests for that bug. See if the test for the feature is disabled by a line that looks something like one of the following:</p>

  <pre class="notranslate">skip-if = toolkit == 'android'
skip-if = os == 'android'</pre>

  <p>If either of those are present, for example, the test is disabled on Android, which means the feature is almost certainly not included on Android. Similar things can happen to disable tests on Mac or Windows.</p>
 </li>
 <li>
  <p>In general, if the files for the feature are located under <code>dom/</code> or other low-level parts of the source tree, the feature is <em>probably</em> available on both desktop and Android.</p>
 </li>
 <li>
  <p>If the feature involves any UI, and the implementation has files under <code>browser/</code> but not under <code>mobile/</code>, then it's pretty likely that the feature is not available on Android (and vice-versa).</p>
 </li>
</ul>

<h3 id="Searchfox">Searchfox</h3>

<p>The <a href="https://searchfox.org/">Searchfox</a> web site provides another method you can use to search Firefox source code. Searchfox is a tool that indexes the Firefox repositories (most usefully, the main <a href="https://searchfox.org/mozilla-central/source">mozilla-central source code</a> and, interesting, the <a href="https://searchfox.org/whatwg-html/source">WHATWG HTML specification is indexed</a> as well).</p>


<h2 id="Opera">Opera</h2>

<p><em>If you have insights into locating release versions for changes to Opera, please consider helping us write this section...</em></p>

<h3 id="Presto">Presto</h3>

<p>Before Opera switched to Chromium, it used an engine developed by Opera called Presto. These resources will help you identify when features were added or removed in Presto-based versions of Opera—that is, Opera version 12.1 and earlier.</p>

<h3 id="Blink_Chromium_2">Blink (Chromium)</h3>

<p>After Opera 12.10, Edge adopted the Blink engine, becoming based upon Chromium. The version number jumped to 15. The Blink engine version became Opera's version plus 13 -- that is, Opera 15 used Blink 28 (15+13=28) -- until Opera Desktop 69 and Opera Android 43. The browser files within the browser-compat-data project contain a mapping of Opera versions to Chromium/Blink versions; see <a href="https://github.com/mdn/browser-compat-data/blob/master/browsers/opera.json">browsers/opera.json</a> and <a href="https://github.com/mdn/browser-compat-data/blob/master/browsers/opera_android.json">browsers/opera_android.json</a>.</p>

<p>While most features will be the same between all Chromium browsers, there may be some exceptions. Here are some resources to help you identify those:</p>

<h2 id="Safari">Safari</h2>

<p>Fortunately, the WebKit source repository, found in SVN and available on the web using Trac, has branches for every WebKit version number, and tags for each Safari version. This makes it actually quite easy to narrow down when a given feature arrives. Find when the entry point for the feature was added, which is often in an IDL file. The WebKit version number at the time is in a <code>Source/WebCore/Configurations/Version.xcconfig</code> or <code>WebCore/Configurations/Version.xcconfig</code> file. The release branch may have already happened, so go through the branches or tags to verify that it was included.</p>

<p>You can then compare the WebKit version number to the Safari version history found on Wikipedia, if necessary, to determine exactly which Safari version was shipped with the change in place.</p>

<h3 id="Useful_links">Useful links</h3>

<ul>
 <li><a href="https://bugs.webkit.org/">WebKit bug database</a></li>
 <li><a href="https://webkit.org/status/">WebKit feature status catalog</a></li>
 <li><a href="https://developer.apple.com/safari/technology-preview/release-notes/">Safari Technology Preview release notes and history</a> (Each Safari tech preview release has notes here)</li>
 <li><a href="https://trac.webkit.org/">Trac revision timeline</a></li>
 <li><a href="https://trac.webkit.org/browser">Browse WebKit source</a>
  <ul>
   <li><a href="https://trac.webkit.org/browser/webkit/releases/Apple">By Apple product release number</a> (Safari, iOS, Safari Technology Preview, watchOS, some older Mac OS X releases). This is how we number Safari in our <a href="https://github.com/mdn/browser-compat-data">Browser Compatibility Database</a>.</li>
   <li><a href="https://trac.webkit.org/browser/webkit/tags">By Safari build number</a> (SVN tags)</li>
   <li><a href="https://trac.webkit.org/browser/webkit/branches">By WebKit build number</a> (SVN branches)</li>
   <li>{{interwiki("wikipedia", "Safari version history")}} (list of Safari versions with feature summaries and the corresponding WebKit build number for each)</li>
  </ul>
 </li>
</ul>

<div class="notecard warning">
<p>Version numbers listed in the documentation at <a href="https://developer.apple.com/documentation/webkitjs">https://developer.apple.com/documentation/webkitjs</a> are inaccurate.  Please use other resources to determine the version numbers.</p>
</div>
